src/Form/TagsType.php
<?php

namespace App\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\CallbackTransformer;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;

class TagsType extends AbstractType {

  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $builder->addViewTransformer(new CallbackTransformer(
      function ($original) {
        return $original ? implode(', ', $original) : '';
      },
      function ($submitted) {
        if (!$submitted) {
          return [];
        }

        $submitted = array_map(function($tag) {
          return trim($tag);
        }, explode(',', $submitted));

        return $submitted;
      }
    ));
  }

  public function getName()
  {
    return 'tags';
  }

  public function getParent()
  {
    return TextType::class;
  }


}

templates/Pratiche/pdf/parts/allegati.html.twig
{% if pratica.allegati|length > 0 %}
    <div class="chiede center_title">
        {{ 'pratica.pdf.allega'|trans() }}
    </div>

    <table class="table">
        <thead>
        <tr>
            <th>{{ 'pratica.dettaglio.allegato.file'|trans }}</th>
            <th>{{ 'pratica.dettaglio.allegato.descrizione'|trans }}</th>
        </tr>
        </thead>
        <tbody>
        {% for allegato in pratica.allegati %}
            <tr>
                <td>{{ allegato.originalFilename }}</td>
                <td>{{ allegato.description }}</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
{% endif %}

templates/Pratiche/pdf/parts/answer_integration.html.twig
{% extends 'Default/printable.html.twig' %}

{% block stylesheets %}
  {{ parent() }}
  {{ include('Pratiche/pdf/parts/style.html.twig') }}
{% endblock %}

{% block main_content %}

  {{ include('Print/parts/_header.html.twig') }}

  <main class="container-fluid">
    <div class="row mt-5">
      <div class="col-12">
        <h1>{{ 'pratica.dettaglio.risposta_integrazione' | trans }}</h1>

        <p>
          <strong>{{ 'pratica.servizio'|trans }}</strong>:{{ pratica.servizio.fullName }}<br>
          <strong>{{ 'pratica.dettaglio.richiedente' | trans }}</strong>: {{ pratica.user.fullName }}<br>
          <strong>{{ 'pratica.numero' | trans }}</strong>: {{ pratica.id }}<br>
          {% if pratica.numeroProtocollo %}
            <strong>{{ 'pratica.protocol_number' | trans }}</strong>: {{ pratica.numeroProtocollo }}
          {% endif %}
        </p>

        {# Richiesta integrazione #}
        {% if integration_request_message %}
          <h3>{{ 'operatori.note_richiesta_del_giorno' | trans({
              '%date%': richiesta_integrazione.createdAt | format_date( locale=app.request.locale)
            }) }}</h3>
          {{ integration_request_message.message | raw }}
        {% endif %}

        {# Integrazioni (solo Peo) #}
        {% if integrazioni|length > 0 %}
          <h3>{{ 'integrations' | trans }}</h3>
          <ul>
            {% for i in integrazioni %}
              <li>{{ i.originalFilename }}</li>
            {% endfor %}
          </ul>
        {% endif %}

        {# Messaggi #}
        {% set attachments = [] %}
        {% if messages|length > 0 %}
          <h3>{{ 'iscrizioni.messages' | trans }}</h3>
          <ul class="list-unstyled">
            {% for message in messages %}
              <li>
                <p>{{ 'from' | trans }}
                  <strong>
                    {{ (message.author is not null) ? message.author.fullName : ente.name }}
                  </strong>
                  {{ 'pratica.dettaglio.il' | trans }} {{ message.createdAt | format_datetime('medium', 'short', locale=app.request.locale) }}
                </p>
                {{ message.message|purify }}
                {% if message.attachments|length > 0 %}
                  <p>{{ 'operatori.allegati' | trans }}:<br>
                    {% for attachment in message.attachments %}
                      {% set attachments = attachments|merge([attachment]) %}
                      <small>{{ attachment.description }}</small>
                    {% endfor %}
                  </p>
                {% endif %}
                <hr>
              </li>
            {% endfor %}
          </ul>
        {% endif %}

        <h3>{{ 'operatori.allegati'|trans }}</h3>
        {% if attachments|length > 0 %}
          <table class="table">
            <thead>
            <tr>
              <th>{{ 'allegato.nome_file' | trans }}</th>
              <th>{{ 'allegato.hash_file' | trans }}</th>
            </tr>
            </thead>
            <tbody>
            {% for a in attachments %}
              <tr>
                <td>{{ a.originalFilename }}</td>
                <td>{{ a.hash }}</td>
              </tr>
            {% endfor %}
            </tbody>
          </table>
        {% else %}
          <p><em>{{ 'pratica.nessun_allegato'|trans }}</em></p>
        {% endif %}

      </div>
    </div>
  </main>
{% endblock %}

templates/Pratiche/pdf/parts/base.html.twig
{% if pratica.ente != null %}
  <div class="destinatario">
    <p><em>{{ 'pratica.pdf.spett_le'|trans() }}</em><br/><strong>{{ pratica.ente.name }}</strong></p>
  </div>
{% endif %}

<table>
  <tr>
    <td width="60%">
      <div class="oggetto">
        {% if pratica.oggetto != null %}
          <p>
            {{ 'pratica.pdf.oggetto'|trans() }}<br/>{{ pratica.oggetto }}
          </p>
        {% else %}
          <p>
            {{ 'pratica.pdf.oggetto'|trans() }}<br/>{{ oggetto|default(pratica.servizio.name) }}
          </p>
        {% endif %}
      </div>
    </td>
    <td>
      {% if pratica.numeroProtocollo %}
        <div class="dati_protocollo">
          <table>
            <tr>
              <td>{{ 'pratica.protocollo'|trans }}</td>
            </tr>
            <tr>
              <td>{{ pratica.numeroProtocollo }}</td>
            </tr>
          </table>
        </div>
      {% endif %}
    </td>
  </tr>
</table>


<div class="dati_richiedente">
  <p>
    {{ 'pratica.pdf.il_sottoscritto'|trans() }} <span
      class="text-uppercase">{{ pratica.richiedenteCognome }} {{ pratica.richiedenteNome }}</span> {% if pratica.user.sesso %}sesso
      <span class="text-uppercase">{{ pratica.user.sesso }}</span>{% endif %}
    {{ 'pratica.pdf.nato_il'|trans() }} <span
      class="text-uppercase">{{ pratica.richiedenteDataNascita|date("d/m/Y") }}</span> {% if pratica.richiedenteLuogoNascita %}a
      <span class="text-uppercase">{{ pratica.richiedenteLuogoNascita }}</span>{% endif %}
    <br/>
    {{ 'pratica.pdf.codice_ficale'|trans() }} <span class="text-uppercase">{{ pratica.user.codiceFiscale }}</span>
    <br/>
    {{ 'pratica.pdf.residente_in'|trans() }} <span
      class="text-uppercase">{{ pratica.richiedenteIndirizzoResidenza }}{{ pratica.richiedenteCapResidenza }} {{ pratica.richiedenteCittaResidenza }}</span>
    <br/>
    {{ 'pratica.pdf.telefono'|trans() }} <span
      class="text-uppercase">{{ pratica.richiedenteTelefono }}</span> {{ 'pratica.pdf.email'|trans() }} <span
      class="text-uppercase">{{ pratica.richiedenteEmail }}</span>
  </p>
</div>

templates/Pratiche/pdf/parts/base_logo.twig
{% set ente = instance_service.getCurrentInstance() %}
{% set customName = ente.getMetaAsArray('name') %}
{% set enteName = customName != '' ? customName :  ente.name %}
{% set host_url = ocsdc_scheme ~ '://' ~ ocsdc_host ~ '/' %}
{% set logoMeta = ente.getMetaAsArray('logo') %}
{% set logo = logoMeta  ? logoMeta :  host_url ~ 'bundles/app/images/logo-default.png' %}

<!doctype html>
<html lang="it">
<head>
  {{ include('Pratiche/pdf/parts/style.html.twig') }}
</head>
<body>

<main>
  <div class="header">
    <div class="text-center">
      {% if ente %}
        <img class="logo" src="{{ logo }}" alt="{{ enteName }}"/>
        <h2>{{ enteName }}</h2>
      {% endif %}
    </div>
  </div>

  {% block pdf_content %}{% endblock %}
</main>

</body>
</html>

templates/Pratiche/pdf/parts/cancel_integration.html.twig
{% extends 'Default/printable.html.twig' %}

{% block stylesheets %}
  {{ parent() }}
  {{ include('Pratiche/pdf/parts/style.html.twig') }}
{% endblock %}

{% block main_content %}

  {{ include('Print/parts/_header.html.twig') }}

  <main class="container-fluid">
    <div class="row mt-5">
      <div class="col-12">
        <h1>{{ 'pratica.dettaglio.integrazione_annullata'|trans }}</h3>

        <p>
          <strong>{{ 'pratica.servizio'|trans }}</strong>:{{ pratica.servizio.fullName }}<br>
          <strong>{{ 'pratica.dettaglio.richiedente' | trans }}</strong>: {{ pratica.user.fullName }}<br>
          <strong>{{ 'pratica.numero' | trans }}</strong>: {{ pratica.id }}<br>
          {% if pratica.numeroProtocollo %}
            <strong>{{ 'pratica.protocol_number' | trans }}</strong>: {{ pratica.numeroProtocollo }}
          {% endif %}
        </p>

        {# Richiesta integrazione #}
        {% if integration_request_message %}
          <h3>{{ 'operatori.note_richiesta_del_giorno' | trans({
              '%date%': richiesta_integrazione.createdAt | format_date( locale=app.request.locale)
            }) }}</h3>
          {{ integration_request_message.message |raw }}
        {% endif %}

        <h4>{{ 'pratica.dettaglio.integrazione_annullata_da' | trans({'%operator_fullname%': pratica.operatore.fullName}) }}</h4>

      </div>
    </div>
  </main>
{% endblock %}

templates/Pratiche/pdf/parts/data_luogo.html.twig
<div class="data">
    <p>{{ 'pratica.pdf.luogo'|trans()|raw }} {{ pratica.submissionTime|date("d/m/Y") }}</p>
</div>

templates/Pratiche/pdf/parts/dati_autenticazione.html.twig
{# @var pratica \App\Entity\Pratica #}
{# @var user \App\Entity\CPSUser #}
<p class="page-break-before">{{ 'pratica.pdf.dati_autenticazione'|trans|raw }}</p>
<table style="font-size: 8pt;table-layout: fixed; background-color: #e3e3e3; border: 1px solid #ccc" class="table autenticazione">
  {% if pratica.authenticationData|length > 0 %}
    {% set securityFields = pratica.authenticationData %}
  {% else %}
    {% set securityFields = user.getSecurityFields %}
  {% endif %}

  {% if securityFields|length %}
    {% for key, value in securityFields %}
      <tr>
        <td width="30%">{{ key }}</td>
        <td style="word-break: break-word;overflow-wrap: break-word;">{{ value }}</td>
      </tr>
    {% endfor %}
  {% endif %}
</table>

templates/Pratiche/pdf/parts/delega_richiesta.html.twig
{% set data = pratica.getDelegaDataArray %}
<div class="richiesta">
    <p style="text-align: center">
        {{ 'certificato_nascita.pdf.richiesta'|trans() }}
        {% if pratica.tipologiaCertificatoAnagrafico != 'semplice' %}
            <i>{{ ('steps.common.certificato_anagrafico.tipologie.' ~ pratica.tipologiaCertificatoAnagrafico)|trans }}</i>
        {% endif %}
        {% if pratica.delegaType %}
            relativo alla persona:
        {% endif %}
    </p>
</div>
{% if pratica.delegaType %}
    <div class="delega_richiesta">
        <p>
            <span class="text-uppercase">{{ data.nome_soggetto_certificato }}</span> {{ 'pratica.dettaglio.delega.cf'|trans }} <span class="text-uppercase">{{ pratica.relatedCfs }}</span>
            {{ 'pratica.pdf.nato_il'|trans() }} <span class="text-uppercase">{{ data.data_nascita_soggetto_certificato }}</span>
        </p>

        <p>
            {{ 'steps.common.certificato_anagrafico.uso'|trans }} <span class="text-uppercase">{{ pratica.usoCertificatoAnagrafico }}</span>
        </p>
    </div>
{% endif %}

<p>
    {{ 'certificato_anagrafico.pdf.dichiara'|trans|raw }}
</p>

templates/Pratiche/pdf/parts/delega_ruolo.html.twig
{% set data = pratica.getDelegaDataArray %}
{% if pratica.delegaType %}
    <div class="delega_ruolo">
        <div class="chiede center_title">
            <strong>{{ 'pratica.dettaglio.delega.ruolo'|trans }}</strong>
        </div>
        <p>
            {% if pratica.delegaType == 'altro' %}
            <span class="text-uppercase">{{ data.delega_type_text }}</span>>
            {% elseif pratica.delegaType == 'incaricato' %}
                {{ ('steps.common.delega.tipi.' ~ pratica.delegaType)|trans }} <span class="text-uppercase">{{ data.delega_type_text }}</span>
            {% else %}
                {{ ('steps.common.delega.tipi.' ~ pratica.delegaType)|trans }} <span class="text-uppercase">{{ data.nome_soggetto_certificato }}</span>
            {% endif %}
        </p>

    </div>
{% endif %}

templates/Pratiche/pdf/parts/footer.html.twig
<div id="footer">
  <p>
    {{ 'pratica.pdf.riferimento_sdc'|trans }} {{ url('pratiche_show', {'pratica': pratica.id}) }}
  </p>
</div>

templates/Pratiche/pdf/parts/header.html.twig
<!DOCTYPE html>
<html>
<head>
</head>
<body style="padding:0; margin:0; font-family: 'Arial', sans-serif;">
</body>
</html>

templates/Pratiche/pdf/parts/integration.html.twig
{% extends 'Default/printable.html.twig' %}

{% block stylesheets %}
  {{ parent() }}
  {{ include('Pratiche/pdf/parts/style.html.twig') }}
{% endblock %}

{% block main_content %}

  {{ include('Print/parts/_header.html.twig') }}

  <main class="container-fluid">
    <div class="row mt-5">
      <div class="col-12">
        <h1>{{ 'pratica.dettaglio.richiesta_integrazione'|trans }}</h1>

        <p>
          <strong>{{ 'pratica.servizio'|trans }}</strong>:{{ pratica.servizio.fullName }}<br>
          <strong>{{ 'pratica.dettaglio.richiedente' | trans }}</strong>: {{ pratica.user.fullName }}<br>
          <strong>{{ 'pratica.numero' | trans }}</strong>: {{ pratica.id }}<br>
          {% if pratica.numeroProtocollo %}
            <strong>{{ 'pratica.protocol_number' | trans }}</strong>: {{ pratica.numeroProtocollo }}
          {% endif %}
        </p>

        {# Richiesta integrazione #}
        {% if integration_request.message %}
          <h3 class="mt-5">{{ 'operatori.note_richiesta' | trans }}</h3>
          {{ integration_request.message|raw }}
        {% endif %}

        {# Allegati #}
        <h3 class="mt-5">{{ 'operatori.allegati'|trans }}</h3>
        {% if attachments|length > 0 %}
          <table class="table">
            <thead>
            <tr>
              <th>{{ 'allegato.nome_file' | trans }}</th>
              <th>{{ 'allegato.hash_file' | trans }}</th>
            </tr>
            </thead>
            <tbody>
            {% for a in attachments %}
              <tr>
                <td>{{ a.originalFilename }}</td>
                <td>{{ a.hash }}</td>
              </tr>
            {% endfor %}
            </tbody>
          </table>
        {% else %}
          <p><em>{{ 'pratica.nessun_allegato'|trans }}</em></p>
        {% endif %}
      </div>
    </div>
  </main>
{% endblock %}

templates/Pratiche/pdf/parts/payment_gateway.html.twig
{% if pratica.paymentType and pratica.paymentType == 'bollo' %}
    <div class="payment">
        <p><strong>{{ 'pratica.pagamento'|trans }}</strong></p>
        {{ include('Gateway/pdf/_bollo.html.twig', {'pratica':pratica}) }}
    </div>
{% endif %}

templates/Pratiche/pdf/parts/style.html.twig
<style>
  body {
    margin: 0;
    padding: 0 40pt;
    line-height: 25pt;
    color: #222;
    font: 13pt Arial, Helvetica, sans-serif;
    line-height: 1.3;
    background: #fff !important;
  }

  h1 {
    font-size: 24pt;
  }

  h2, h3, h4 {
    font-size: 14pt;
    margin-top: 25px;
  }

  a:link, a:visited, a {
    background: transparent;
    color: #520;
    font-weight: bold;
    text-decoration: underline;
    text-align: left;
  }

  p, address, li, dt, dd, blockquote {
    font-size: 100%
  }

  code, pre {
    font-family: "Courier New", Courier, mono, serif
  }

  ul, ol {
    list-style: square; margin-left: 18pt;
    margin-bottom: 20pt;
  }

  li {
    line-height: 1.6em;
  }

  hr {
    margin: 20pt;
  }

  .header {
    padding: 20pt 0pt;
  }

  .text-center {
      text-align: center!important;
  }

  .logo {
      max-height: 100px;
  }

  .ente {
      margin-top: 15px;
  }

  .destinatario {
    text-align: right;
    margin: 30pt 0;
  }

  .oggetto {
    text-transform: uppercase;
    font-weight: bold;
    margin-bottom: 30pt;
  }

  .chiede {
    font-weight: bold;
    font-style: italic;
    text-align: center;
    margin: 25pt 0;
  }

  .richiesta {
    margin-top: 25pt;
  }

  .table {
    margin: 20pt 0;
    width: 100%;
    border-collapse: collapse;
    border-spacing: 0;
    font-size: 80%;
  }

  .table > caption + thead > tr:first-child > td, .table > caption + thead > tr:first-child > th, .table > colgroup + thead > tr:first-child > td, .table > colgroup + thead > tr:first-child > th, .table > thead:first-child > tr:first-child > td, .table > thead:first-child > tr:first-child > th {
    border-top: 0 none;
  }

  .table > tbody > tr > td, .table > tbody > tr > th, .table > tfoot > tr > td, .table > tfoot > tr > th, .table > thead > tr > td, .table > thead > tr > th {
    border-top: 1px solid #ddd;
    line-height: 1.55556;
    padding: 8px;
    vertical-align: top;
  }

  .table th {
    font-weight: bold;
    text-align: left;
    background-color: #EFEFEF;
    width: 50%;
  }

  .table td {
    text-align: left;
  }

  .table td span.text-uppercase {
    font-weight: bold;
  }

  .data {
    margin-top: 30pt;
  }

  .dati_protocollo {
    border: 2px solid #ff0000;
    color: #ff0000;
  }

  .dati_protocollo table tr td {
    text-align: center;
    color: #ff0000;
    padding: 10px;
    font-weight: bold;
  }

  .text-uppercase {
    text-transform: uppercase;
    font-weight: bold;
  }

  .page-break-before {
    page-break-before: always;
  }

  .page-break-after {
    page-break-after: always;
  }

  .list-unstyled {
    list-style-type: none;
    padding: 0;
  }

  #footer {
    background-color: #f2f2f2;
    bottom: 0;
    box-sizing: border-box;
    height: 60px;
    text-align: center;
    position: fixed;
    left: 0;
    right: 0;
    font-size: 11px;
    border-top: 2px solid #3478bd;
    padding-top: 10px;
  }
</style>